;                           
;                PHILIPS PCD 8544 (NOKIA 3310, 5110) 
;                              (Vitaly V Gorbukov)
;                              gorbukov@yandex.ru   http://vg.ucoz.ru
; 
;1.      
; 
; :
;
; LCD_INIT -  
;
; LCD_POS (R17=X, R18=Y) -     (    )
;
; LCD_CHAR (R16=char) -    
;
;
;        
;    17 : 
; +-------+----+----+----+----+----+----+----+----+
; |    |0x00|0x01|0x02|0x03|0x04|0x05|0x06|0x07|
; +-------+----+----+----+----+----+----+----+----+
; | |  0 |  1 |  2 |  3 |  4 |  5 |  6 |  7 |
; +-------+----+----+----+----+----+----+----+----+
;
; +-------+----+----+----+----+----+----+----+----+--------------+
; |    |0x08|0x09|0x0A|0x0B|0x0C|0x0D|0x0E|0x0F|0x10          |
; +-------+----+----+----+----+----+----+----+----+--------------+
; | |  8 |  9 |  A |  B |  C |  D |  E |  F |  ' ' ()|
; +-------+----+----+----+----+----+----+----+----+--------------+
;
;     58  (4 .    + 1   
;     )
;
;    ( )
;+--------------------------------------------------------------+
;|.include "m32def.inc" ;          |
;|                                                              |
;|.CSEG								|
;|.ORG 0x0000							|
;|		RJMP START					|
;|       . . . . .     . . . . .	|
;|START:							|
;|       . . . .   	  . . . . .		|
;|       . . . . .   . . . . .			|
;|								|
;|								|
;|	RCALL LCD_INIT		;   !	|
;|								|
;|	LDI R16	, 0x00		;   '0'		|
;|	RCALL LCD_CHAR						|
;|								|
;|	LDI R16	, 0x10		;   ' ' ()	|
;|	RCALL LCD_CHAR						|
;|								|
;|				;  	|																|
;|	LDI R18	, 2		;(Y) 3  (0/1/2/3/4/5)	|
;|	LDI R17	, 40		;(X) 41   	|
;|			(0/5/10/..../80)  (84  )	|
;|								|
;|	RCALL LCD_POS						|
;|								|
;|	LDI R16	, 0x0F		;   'F'		|
;|	RCALL	LCD_CHAR					|
;|								|
;|     . . . . .   . . . . .		|
;|								|
;|LOOP:								|
;|		rjmp 	LOOP	;   ()		|
;|								|
;|.include "lcd5110mini.asm" ;   	|
;+--------------------------------------------------------------+
;
;
;
;2.     
;
; ------------------------------------------------------------------------------------------
;
;  ! 
;      3.3 ,       
;  5  -      -  !
;
; +---------------------+
; |   |
; +---------------------+
;         :
;        D (  PORTD;   DDRD)
; ,    A   PORTA  DDRA,      )
;
;     (RST, RES. RESET)
.equ   RSTPORT =PORTC ;      RST (RES, RESET)
.equ   RSTDDR  =DDRC
.equ   RSTPIN  =3      ;   

;     (MOSI, DI)
.equ   MOSIPORT=PORTC   ;      MOSI ( DI)
.equ   MOSIDDR  =DDRC
.equ   MOSIPIN  =1       ;   

;    \ (DC, D/C)
.equ   DCPORT  =PORTC   ;      DC (D/C)
.equ   DCDDR   =DDRC
.equ   DCPIN   =2       ;   

;    (CLK, SCK, CLOCK)
.equ   CLKPORT =PORTC   ;      CLK (SCK, CLOCK)
.equ   CLKDDR  =DDRC
.equ   CLKPIN  =0       ;   

;    SCE (CS)     !
;
;          
;
;     (RST, MOSI, DC, CLK)     \
;    DDR_ONE_LINE,   DDR_MULTI_LINE
;
;       ,      DDR_ONE_LINE
;         DDR_MULTU_LINE  18 
;
;
; !           !
;              DDR_ONE_LINE
.MACRO  DDR_INIT
						DDR_ONE_LINE    	;     
;						DDR_MULTI_LINE  	;     
.ENDMACRO

;   ,         !
;    Nokia 5110, 3310
LCD_INIT_STR:			.DB 0x21, 0xC2, 0x06, 0x13, 0x20, 0x0C, 0x80, 0x40
.equ                    LCD_INIT_LEN = 8  ;   

;    Simens C55 (  !)
;LCD_INIT_STR:			.DB 0x21, 0x09, 0xE0, 0x16, 0x06, 0x20, 0x0C, 0x80, 0x40
;.equ                    LCD_INIT_LEN = 9 ;   


;=========================     !!! ============================

.MACRO DDR_ONE_LINE    	;     
						;                 RST          MOSI         DC       SCK
						in		R16		, DDRB	
						ori		R16 , (1<<RSTPIN)|(1<<MOSIPIN)|(1<<DCPIN)|(1<<CLKPIN)
						out		MOSIDDR	, R16
.ENDMACRO

.MACRO DDR_MULTI_LINE  	;     
						in		R16		, RSTDDR
						ori		R16 	, (1<<RSTPIN)
						out		RSTDDR	, R16

						in		R16		, MOSIDDR
						ori		R16 	, (1<<MOSIPIN)
						out		MOSIDDR	, R16

						in		R16		, DCDDR
						ori		R16 	, (1<<DCPIN)
						out		DCDDR	, R16

						in		R16		, CLKDDR
						ori		R16 	, (1<<CLKPIN)
						out		CLKDDR	, R16
.ENDMACRO

LCD_INIT:	; --------------------------------------------------------------  LCD

						DDR_INIT		;    

 										;  
						cbi   RSTPORT , RSTPIN    ; RST=0


						ldi		ZL	, low (LCD_INIT_STR*2) ;   

						sbi   RSTPORT , RSTPIN    ; RST=1

						ldi		ZH	, high(LCD_INIT_STR*2)
						ldi		R17	, LCD_INIT_LEN         ;   

						cbi   DCPORT , DCPIN    ; DC=0  

LCD_INIT_loop:          ;     
						lpm		R16	, Z+
						rcall 	LCD_SENDBYTE
						dec		R17
						brne	LCD_INIT_loop           

						sbi   DCPORT , DCPIN    ; DC=1  

						clr		R16        ;  
						ldi		R17	, 252
LCD_INIT_CLR_loop:		rcall	LCD_SENDBYTE
						rcall	LCD_SENDBYTE
						DEC		R17
						BRNE	LCD_INIT_CLR_loop

                        ret 
					    

LCD_POS: 	;--------------------------------------------------------- 
            ;                                                             R17=X  R18=Y
						push	R16

						cbi   	DCPORT , DCPIN    ; DC=0

;                       ldi     R16 , 0x20     ;   
; 						rcall	LCD_SENDBYTE

                        ldi     R16 , 0x80
						add     R16 , R17      ; X 
						rcall	LCD_SENDBYTE

                        ldi     R16 , 0x40
						add     R16 , R18      ; Y 
						rcall	LCD_SENDBYTE

						pop		R16
						ret



LCD_SENDBYTE:	;----------------------------------------     (R16 )
                        push  R17
						push  R16

				        ldi   R17 , 8     ;    
LCD_SENDBYTE_loop:
                        cbi		MOSIPORT , MOSIPIN   ; mosi=0
						sbrc	R16 , 7
                        sbi		MOSIPORT , MOSIPIN   ; mosi=1

						sbi		CLKPORT  , CLKPIN    ; sck=1
                        lsl		R16
						cbi		CLKPORT  , CLKPIN    ; sck=0

						dec		R17
						brne	LCD_SENDBYTE_loop

						pop		R16
                        pop		R17
						ret

LCD_CHAR:	; ---------------------------------------------------------------  
			;                                                                  R16 - 
			            push	ZL
						push	ZH
						push	R17

						sbi   	DCPORT , DCPIN     ; DC=1

						LDI		ZL	, low (lcd_charset*2)
						LDI		ZH	, high(lcd_charset*2)
						LDI		R17	, 0
						LSL     R16
						LSL     R16
						ADD		ZL	, R16
						ADC		ZH	, R17

						LDI		R17	, 4
LCD_CHAR_LOOP:          ;    
						LPM		R16	, Z+
						RCALL	LCD_SENDBYTE
						DEC		R17
						BRNE	LCD_CHAR_LOOP

						CLR		R16				;   
						RCALL	LCD_SENDBYTE

						pop		R17
						pop		ZH
						pop		ZL
						RET

lcd_charset:	;    
				.db 0x3E, 0x41, 0x41, 0x3E	; 0
				.db 0x44, 0x42, 0x7F, 0x40	; 1
				.db 0x42, 0x61, 0x51, 0x4E	; 2
				.db 0x22, 0x41, 0x49, 0x36	; 3
				.db 0x1C, 0x12, 0x79, 0x10	; 4
				.db 0x27, 0x45, 0x45, 0x39	; 5
				.db 0x3E, 0x49, 0x49, 0x32	; 6
				.db 0x01, 0x71, 0x09, 0x07	; 7
				.db 0x36, 0x49, 0x49, 0x36	; 8
				.db 0x26, 0x49, 0x49, 0x3E	; 9
				.db 0x7C, 0x12, 0x11, 0x7E	; A
				.db 0x7F, 0x49, 0x49, 0x36	; B
				.db 0x3E, 0x41, 0x41, 0x22	; C
				.db 0x7F, 0x41, 0x22, 0x1C	; D 
				.db 0x7F, 0x49, 0x49, 0x49	; E
				.db 0x7F, 0x09, 0x09, 0x01	; F
				.db 0x00, 0x00, 0x00, 0x00	; 
